# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SpringCloudServiceArgs', 'SpringCloudService']

@pulumi.input_type
class SpringCloudServiceArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[str],
                 build_agent_pool_size: Optional[pulumi.Input[str]] = None,
                 config_server_git_setting: Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']] = None,
                 container_registries: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]] = None,
                 default_build_service: Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 log_stream_public_endpoint_enabled: Optional[pulumi.Input[bool]] = None,
                 managed_environment_id: Optional[pulumi.Input[str]] = None,
                 marketplace: Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network: Optional[pulumi.Input['SpringCloudServiceNetworkArgs']] = None,
                 service_registry_enabled: Optional[pulumi.Input[bool]] = None,
                 sku_name: Optional[pulumi.Input[str]] = None,
                 sku_tier: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 trace: Optional[pulumi.Input['SpringCloudServiceTraceArgs']] = None,
                 zone_redundant: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a SpringCloudService resource.
        :param pulumi.Input[str] resource_group_name: Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        :param pulumi.Input[str] build_agent_pool_size: Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs'] config_server_git_setting: A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        :param pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]] container_registries: One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs'] default_build_service: A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] location: Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] log_stream_public_endpoint_enabled: Should the log stream in vnet injection instance could be accessed from Internet?
        :param pulumi.Input[str] managed_environment_id: The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        :param pulumi.Input['SpringCloudServiceMarketplaceArgs'] marketplace: A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        :param pulumi.Input[str] name: Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        :param pulumi.Input['SpringCloudServiceNetworkArgs'] network: A `network` block as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] service_registry_enabled: Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] sku_name: Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku_tier: Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input['SpringCloudServiceTraceArgs'] trace: A `trace` block as defined below.
        :param pulumi.Input[bool] zone_redundant: Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if build_agent_pool_size is not None:
            pulumi.set(__self__, "build_agent_pool_size", build_agent_pool_size)
        if config_server_git_setting is not None:
            pulumi.set(__self__, "config_server_git_setting", config_server_git_setting)
        if container_registries is not None:
            pulumi.set(__self__, "container_registries", container_registries)
        if default_build_service is not None:
            pulumi.set(__self__, "default_build_service", default_build_service)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if log_stream_public_endpoint_enabled is not None:
            pulumi.set(__self__, "log_stream_public_endpoint_enabled", log_stream_public_endpoint_enabled)
        if managed_environment_id is not None:
            pulumi.set(__self__, "managed_environment_id", managed_environment_id)
        if marketplace is not None:
            pulumi.set(__self__, "marketplace", marketplace)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network is not None:
            pulumi.set(__self__, "network", network)
        if service_registry_enabled is not None:
            pulumi.set(__self__, "service_registry_enabled", service_registry_enabled)
        if sku_name is not None:
            pulumi.set(__self__, "sku_name", sku_name)
        if sku_tier is not None:
            pulumi.set(__self__, "sku_tier", sku_tier)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if trace is not None:
            pulumi.set(__self__, "trace", trace)
        if zone_redundant is not None:
            pulumi.set(__self__, "zone_redundant", zone_redundant)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="buildAgentPoolSize")
    def build_agent_pool_size(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "build_agent_pool_size")

    @build_agent_pool_size.setter
    def build_agent_pool_size(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "build_agent_pool_size", value)

    @property
    @pulumi.getter(name="configServerGitSetting")
    def config_server_git_setting(self) -> Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']]:
        """
        A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        """
        return pulumi.get(self, "config_server_git_setting")

    @config_server_git_setting.setter
    def config_server_git_setting(self, value: Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']]):
        pulumi.set(self, "config_server_git_setting", value)

    @property
    @pulumi.getter(name="containerRegistries")
    def container_registries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]]:
        """
        One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "container_registries")

    @container_registries.setter
    def container_registries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]]):
        pulumi.set(self, "container_registries", value)

    @property
    @pulumi.getter(name="defaultBuildService")
    def default_build_service(self) -> Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']]:
        """
        A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "default_build_service")

    @default_build_service.setter
    def default_build_service(self, value: Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']]):
        pulumi.set(self, "default_build_service", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="logStreamPublicEndpointEnabled")
    def log_stream_public_endpoint_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Should the log stream in vnet injection instance could be accessed from Internet?
        """
        return pulumi.get(self, "log_stream_public_endpoint_enabled")

    @log_stream_public_endpoint_enabled.setter
    def log_stream_public_endpoint_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_stream_public_endpoint_enabled", value)

    @property
    @pulumi.getter(name="managedEnvironmentId")
    def managed_environment_id(self) -> Optional[pulumi.Input[str]]:
        """
        The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        """
        return pulumi.get(self, "managed_environment_id")

    @managed_environment_id.setter
    def managed_environment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "managed_environment_id", value)

    @property
    @pulumi.getter
    def marketplace(self) -> Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']]:
        """
        A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        """
        return pulumi.get(self, "marketplace")

    @marketplace.setter
    def marketplace(self, value: Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']]):
        pulumi.set(self, "marketplace", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def network(self) -> Optional[pulumi.Input['SpringCloudServiceNetworkArgs']]:
        """
        A `network` block as defined below. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "network")

    @network.setter
    def network(self, value: Optional[pulumi.Input['SpringCloudServiceNetworkArgs']]):
        pulumi.set(self, "network", value)

    @property
    @pulumi.getter(name="serviceRegistryEnabled")
    def service_registry_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "service_registry_enabled")

    @service_registry_enabled.setter
    def service_registry_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "service_registry_enabled", value)

    @property
    @pulumi.getter(name="skuName")
    def sku_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_name")

    @sku_name.setter
    def sku_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sku_name", value)

    @property
    @pulumi.getter(name="skuTier")
    def sku_tier(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_tier")

    @sku_tier.setter
    def sku_tier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sku_tier", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A mapping of tags to assign to the resource.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def trace(self) -> Optional[pulumi.Input['SpringCloudServiceTraceArgs']]:
        """
        A `trace` block as defined below.
        """
        return pulumi.get(self, "trace")

    @trace.setter
    def trace(self, value: Optional[pulumi.Input['SpringCloudServiceTraceArgs']]):
        pulumi.set(self, "trace", value)

    @property
    @pulumi.getter(name="zoneRedundant")
    def zone_redundant(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        return pulumi.get(self, "zone_redundant")

    @zone_redundant.setter
    def zone_redundant(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "zone_redundant", value)


@pulumi.input_type
class _SpringCloudServiceState:
    def __init__(__self__, *,
                 build_agent_pool_size: Optional[pulumi.Input[str]] = None,
                 config_server_git_setting: Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']] = None,
                 container_registries: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]] = None,
                 default_build_service: Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 log_stream_public_endpoint_enabled: Optional[pulumi.Input[bool]] = None,
                 managed_environment_id: Optional[pulumi.Input[str]] = None,
                 marketplace: Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network: Optional[pulumi.Input['SpringCloudServiceNetworkArgs']] = None,
                 outbound_public_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 required_network_traffic_rules: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 service_registry_enabled: Optional[pulumi.Input[bool]] = None,
                 service_registry_id: Optional[pulumi.Input[str]] = None,
                 sku_name: Optional[pulumi.Input[str]] = None,
                 sku_tier: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 trace: Optional[pulumi.Input['SpringCloudServiceTraceArgs']] = None,
                 zone_redundant: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering SpringCloudService resources.
        :param pulumi.Input[str] build_agent_pool_size: Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs'] config_server_git_setting: A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        :param pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]] container_registries: One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs'] default_build_service: A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] location: Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] log_stream_public_endpoint_enabled: Should the log stream in vnet injection instance could be accessed from Internet?
        :param pulumi.Input[str] managed_environment_id: The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        :param pulumi.Input['SpringCloudServiceMarketplaceArgs'] marketplace: A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        :param pulumi.Input[str] name: Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        :param pulumi.Input['SpringCloudServiceNetworkArgs'] network: A `network` block as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] outbound_public_ip_addresses: A list of the outbound Public IP Addresses used by this Spring Cloud Service.
        :param pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]] required_network_traffic_rules: A list of `required_network_traffic_rules` blocks as defined below.
        :param pulumi.Input[str] resource_group_name: Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] service_registry_enabled: Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] service_registry_id: The ID of the Spring Cloud Service Registry.
        :param pulumi.Input[str] sku_name: Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku_tier: Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input['SpringCloudServiceTraceArgs'] trace: A `trace` block as defined below.
        :param pulumi.Input[bool] zone_redundant: Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        if build_agent_pool_size is not None:
            pulumi.set(__self__, "build_agent_pool_size", build_agent_pool_size)
        if config_server_git_setting is not None:
            pulumi.set(__self__, "config_server_git_setting", config_server_git_setting)
        if container_registries is not None:
            pulumi.set(__self__, "container_registries", container_registries)
        if default_build_service is not None:
            pulumi.set(__self__, "default_build_service", default_build_service)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if log_stream_public_endpoint_enabled is not None:
            pulumi.set(__self__, "log_stream_public_endpoint_enabled", log_stream_public_endpoint_enabled)
        if managed_environment_id is not None:
            pulumi.set(__self__, "managed_environment_id", managed_environment_id)
        if marketplace is not None:
            pulumi.set(__self__, "marketplace", marketplace)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network is not None:
            pulumi.set(__self__, "network", network)
        if outbound_public_ip_addresses is not None:
            pulumi.set(__self__, "outbound_public_ip_addresses", outbound_public_ip_addresses)
        if required_network_traffic_rules is not None:
            pulumi.set(__self__, "required_network_traffic_rules", required_network_traffic_rules)
        if resource_group_name is not None:
            pulumi.set(__self__, "resource_group_name", resource_group_name)
        if service_registry_enabled is not None:
            pulumi.set(__self__, "service_registry_enabled", service_registry_enabled)
        if service_registry_id is not None:
            pulumi.set(__self__, "service_registry_id", service_registry_id)
        if sku_name is not None:
            pulumi.set(__self__, "sku_name", sku_name)
        if sku_tier is not None:
            pulumi.set(__self__, "sku_tier", sku_tier)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if trace is not None:
            pulumi.set(__self__, "trace", trace)
        if zone_redundant is not None:
            pulumi.set(__self__, "zone_redundant", zone_redundant)

    @property
    @pulumi.getter(name="buildAgentPoolSize")
    def build_agent_pool_size(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "build_agent_pool_size")

    @build_agent_pool_size.setter
    def build_agent_pool_size(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "build_agent_pool_size", value)

    @property
    @pulumi.getter(name="configServerGitSetting")
    def config_server_git_setting(self) -> Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']]:
        """
        A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        """
        return pulumi.get(self, "config_server_git_setting")

    @config_server_git_setting.setter
    def config_server_git_setting(self, value: Optional[pulumi.Input['SpringCloudServiceConfigServerGitSettingArgs']]):
        pulumi.set(self, "config_server_git_setting", value)

    @property
    @pulumi.getter(name="containerRegistries")
    def container_registries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]]:
        """
        One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "container_registries")

    @container_registries.setter
    def container_registries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceContainerRegistryArgs']]]]):
        pulumi.set(self, "container_registries", value)

    @property
    @pulumi.getter(name="defaultBuildService")
    def default_build_service(self) -> Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']]:
        """
        A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "default_build_service")

    @default_build_service.setter
    def default_build_service(self, value: Optional[pulumi.Input['SpringCloudServiceDefaultBuildServiceArgs']]):
        pulumi.set(self, "default_build_service", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="logStreamPublicEndpointEnabled")
    def log_stream_public_endpoint_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Should the log stream in vnet injection instance could be accessed from Internet?
        """
        return pulumi.get(self, "log_stream_public_endpoint_enabled")

    @log_stream_public_endpoint_enabled.setter
    def log_stream_public_endpoint_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "log_stream_public_endpoint_enabled", value)

    @property
    @pulumi.getter(name="managedEnvironmentId")
    def managed_environment_id(self) -> Optional[pulumi.Input[str]]:
        """
        The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        """
        return pulumi.get(self, "managed_environment_id")

    @managed_environment_id.setter
    def managed_environment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "managed_environment_id", value)

    @property
    @pulumi.getter
    def marketplace(self) -> Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']]:
        """
        A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        """
        return pulumi.get(self, "marketplace")

    @marketplace.setter
    def marketplace(self, value: Optional[pulumi.Input['SpringCloudServiceMarketplaceArgs']]):
        pulumi.set(self, "marketplace", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def network(self) -> Optional[pulumi.Input['SpringCloudServiceNetworkArgs']]:
        """
        A `network` block as defined below. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "network")

    @network.setter
    def network(self, value: Optional[pulumi.Input['SpringCloudServiceNetworkArgs']]):
        pulumi.set(self, "network", value)

    @property
    @pulumi.getter(name="outboundPublicIpAddresses")
    def outbound_public_ip_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of the outbound Public IP Addresses used by this Spring Cloud Service.
        """
        return pulumi.get(self, "outbound_public_ip_addresses")

    @outbound_public_ip_addresses.setter
    def outbound_public_ip_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "outbound_public_ip_addresses", value)

    @property
    @pulumi.getter(name="requiredNetworkTrafficRules")
    def required_network_traffic_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]]]:
        """
        A list of `required_network_traffic_rules` blocks as defined below.
        """
        return pulumi.get(self, "required_network_traffic_rules")

    @required_network_traffic_rules.setter
    def required_network_traffic_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]]]):
        pulumi.set(self, "required_network_traffic_rules", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="serviceRegistryEnabled")
    def service_registry_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "service_registry_enabled")

    @service_registry_enabled.setter
    def service_registry_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "service_registry_enabled", value)

    @property
    @pulumi.getter(name="serviceRegistryId")
    def service_registry_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the Spring Cloud Service Registry.
        """
        return pulumi.get(self, "service_registry_id")

    @service_registry_id.setter
    def service_registry_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_registry_id", value)

    @property
    @pulumi.getter(name="skuName")
    def sku_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_name")

    @sku_name.setter
    def sku_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sku_name", value)

    @property
    @pulumi.getter(name="skuTier")
    def sku_tier(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_tier")

    @sku_tier.setter
    def sku_tier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sku_tier", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A mapping of tags to assign to the resource.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def trace(self) -> Optional[pulumi.Input['SpringCloudServiceTraceArgs']]:
        """
        A `trace` block as defined below.
        """
        return pulumi.get(self, "trace")

    @trace.setter
    def trace(self, value: Optional[pulumi.Input['SpringCloudServiceTraceArgs']]):
        pulumi.set(self, "trace", value)

    @property
    @pulumi.getter(name="zoneRedundant")
    def zone_redundant(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        return pulumi.get(self, "zone_redundant")

    @zone_redundant.setter
    def zone_redundant(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "zone_redundant", value)


class SpringCloudService(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 build_agent_pool_size: Optional[pulumi.Input[str]] = None,
                 config_server_git_setting: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceConfigServerGitSettingArgs']]] = None,
                 container_registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceContainerRegistryArgs']]]]] = None,
                 default_build_service: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceDefaultBuildServiceArgs']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 log_stream_public_endpoint_enabled: Optional[pulumi.Input[bool]] = None,
                 managed_environment_id: Optional[pulumi.Input[str]] = None,
                 marketplace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceMarketplaceArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceNetworkArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 service_registry_enabled: Optional[pulumi.Input[bool]] = None,
                 sku_name: Optional[pulumi.Input[str]] = None,
                 sku_tier: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 trace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceTraceArgs']]] = None,
                 zone_redundant: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Manages an Azure Spring Cloud Service.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.ResourceGroup("exampleResourceGroup", location="West Europe")
        example_insights = azure.appinsights.Insights("exampleInsights",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            application_type="web")
        example_spring_cloud_service = azure.appplatform.SpringCloudService("exampleSpringCloudService",
            resource_group_name=example_resource_group.name,
            location=example_resource_group.location,
            sku_name="S0",
            config_server_git_setting=azure.appplatform.SpringCloudServiceConfigServerGitSettingArgs(
                uri="https://github.com/Azure-Samples/piggymetrics",
                label="config",
                search_paths=[
                    "dir1",
                    "dir2",
                ],
            ),
            trace=azure.appplatform.SpringCloudServiceTraceArgs(
                connection_string=example_insights.connection_string,
                sample_rate=10,
            ),
            tags={
                "Env": "staging",
            })
        ```

        ## Import

        Spring Cloud services can be imported using the `resource id`, e.g.

        ```sh
         $ pulumi import azure:appplatform/springCloudService:SpringCloudService example /subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/group1/providers/Microsoft.AppPlatform/spring/spring1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] build_agent_pool_size: Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceConfigServerGitSettingArgs']] config_server_git_setting: A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceContainerRegistryArgs']]]] container_registries: One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceDefaultBuildServiceArgs']] default_build_service: A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] location: Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] log_stream_public_endpoint_enabled: Should the log stream in vnet injection instance could be accessed from Internet?
        :param pulumi.Input[str] managed_environment_id: The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceMarketplaceArgs']] marketplace: A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        :param pulumi.Input[str] name: Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceNetworkArgs']] network: A `network` block as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[str] resource_group_name: Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] service_registry_enabled: Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] sku_name: Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku_tier: Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceTraceArgs']] trace: A `trace` block as defined below.
        :param pulumi.Input[bool] zone_redundant: Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SpringCloudServiceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an Azure Spring Cloud Service.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.ResourceGroup("exampleResourceGroup", location="West Europe")
        example_insights = azure.appinsights.Insights("exampleInsights",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name,
            application_type="web")
        example_spring_cloud_service = azure.appplatform.SpringCloudService("exampleSpringCloudService",
            resource_group_name=example_resource_group.name,
            location=example_resource_group.location,
            sku_name="S0",
            config_server_git_setting=azure.appplatform.SpringCloudServiceConfigServerGitSettingArgs(
                uri="https://github.com/Azure-Samples/piggymetrics",
                label="config",
                search_paths=[
                    "dir1",
                    "dir2",
                ],
            ),
            trace=azure.appplatform.SpringCloudServiceTraceArgs(
                connection_string=example_insights.connection_string,
                sample_rate=10,
            ),
            tags={
                "Env": "staging",
            })
        ```

        ## Import

        Spring Cloud services can be imported using the `resource id`, e.g.

        ```sh
         $ pulumi import azure:appplatform/springCloudService:SpringCloudService example /subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/group1/providers/Microsoft.AppPlatform/spring/spring1
        ```

        :param str resource_name: The name of the resource.
        :param SpringCloudServiceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SpringCloudServiceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 build_agent_pool_size: Optional[pulumi.Input[str]] = None,
                 config_server_git_setting: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceConfigServerGitSettingArgs']]] = None,
                 container_registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceContainerRegistryArgs']]]]] = None,
                 default_build_service: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceDefaultBuildServiceArgs']]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 log_stream_public_endpoint_enabled: Optional[pulumi.Input[bool]] = None,
                 managed_environment_id: Optional[pulumi.Input[str]] = None,
                 marketplace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceMarketplaceArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceNetworkArgs']]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 service_registry_enabled: Optional[pulumi.Input[bool]] = None,
                 sku_name: Optional[pulumi.Input[str]] = None,
                 sku_tier: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 trace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceTraceArgs']]] = None,
                 zone_redundant: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SpringCloudServiceArgs.__new__(SpringCloudServiceArgs)

            __props__.__dict__["build_agent_pool_size"] = build_agent_pool_size
            __props__.__dict__["config_server_git_setting"] = config_server_git_setting
            __props__.__dict__["container_registries"] = container_registries
            __props__.__dict__["default_build_service"] = default_build_service
            __props__.__dict__["location"] = location
            __props__.__dict__["log_stream_public_endpoint_enabled"] = log_stream_public_endpoint_enabled
            __props__.__dict__["managed_environment_id"] = managed_environment_id
            __props__.__dict__["marketplace"] = marketplace
            __props__.__dict__["name"] = name
            __props__.__dict__["network"] = network
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["service_registry_enabled"] = service_registry_enabled
            __props__.__dict__["sku_name"] = sku_name
            __props__.__dict__["sku_tier"] = sku_tier
            __props__.__dict__["tags"] = tags
            __props__.__dict__["trace"] = trace
            __props__.__dict__["zone_redundant"] = zone_redundant
            __props__.__dict__["outbound_public_ip_addresses"] = None
            __props__.__dict__["required_network_traffic_rules"] = None
            __props__.__dict__["service_registry_id"] = None
        super(SpringCloudService, __self__).__init__(
            'azure:appplatform/springCloudService:SpringCloudService',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            build_agent_pool_size: Optional[pulumi.Input[str]] = None,
            config_server_git_setting: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceConfigServerGitSettingArgs']]] = None,
            container_registries: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceContainerRegistryArgs']]]]] = None,
            default_build_service: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceDefaultBuildServiceArgs']]] = None,
            location: Optional[pulumi.Input[str]] = None,
            log_stream_public_endpoint_enabled: Optional[pulumi.Input[bool]] = None,
            managed_environment_id: Optional[pulumi.Input[str]] = None,
            marketplace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceMarketplaceArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceNetworkArgs']]] = None,
            outbound_public_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            required_network_traffic_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]]]] = None,
            resource_group_name: Optional[pulumi.Input[str]] = None,
            service_registry_enabled: Optional[pulumi.Input[bool]] = None,
            service_registry_id: Optional[pulumi.Input[str]] = None,
            sku_name: Optional[pulumi.Input[str]] = None,
            sku_tier: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            trace: Optional[pulumi.Input[pulumi.InputType['SpringCloudServiceTraceArgs']]] = None,
            zone_redundant: Optional[pulumi.Input[bool]] = None) -> 'SpringCloudService':
        """
        Get an existing SpringCloudService resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] build_agent_pool_size: Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceConfigServerGitSettingArgs']] config_server_git_setting: A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceContainerRegistryArgs']]]] container_registries: One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceDefaultBuildServiceArgs']] default_build_service: A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] location: Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] log_stream_public_endpoint_enabled: Should the log stream in vnet injection instance could be accessed from Internet?
        :param pulumi.Input[str] managed_environment_id: The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceMarketplaceArgs']] marketplace: A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        :param pulumi.Input[str] name: Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceNetworkArgs']] network: A `network` block as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] outbound_public_ip_addresses: A list of the outbound Public IP Addresses used by this Spring Cloud Service.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SpringCloudServiceRequiredNetworkTrafficRuleArgs']]]] required_network_traffic_rules: A list of `required_network_traffic_rules` blocks as defined below.
        :param pulumi.Input[str] resource_group_name: Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        :param pulumi.Input[bool] service_registry_enabled: Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        :param pulumi.Input[str] service_registry_id: The ID of the Spring Cloud Service Registry.
        :param pulumi.Input[str] sku_name: Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        :param pulumi.Input[str] sku_tier: Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[pulumi.InputType['SpringCloudServiceTraceArgs']] trace: A `trace` block as defined below.
        :param pulumi.Input[bool] zone_redundant: Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SpringCloudServiceState.__new__(_SpringCloudServiceState)

        __props__.__dict__["build_agent_pool_size"] = build_agent_pool_size
        __props__.__dict__["config_server_git_setting"] = config_server_git_setting
        __props__.__dict__["container_registries"] = container_registries
        __props__.__dict__["default_build_service"] = default_build_service
        __props__.__dict__["location"] = location
        __props__.__dict__["log_stream_public_endpoint_enabled"] = log_stream_public_endpoint_enabled
        __props__.__dict__["managed_environment_id"] = managed_environment_id
        __props__.__dict__["marketplace"] = marketplace
        __props__.__dict__["name"] = name
        __props__.__dict__["network"] = network
        __props__.__dict__["outbound_public_ip_addresses"] = outbound_public_ip_addresses
        __props__.__dict__["required_network_traffic_rules"] = required_network_traffic_rules
        __props__.__dict__["resource_group_name"] = resource_group_name
        __props__.__dict__["service_registry_enabled"] = service_registry_enabled
        __props__.__dict__["service_registry_id"] = service_registry_id
        __props__.__dict__["sku_name"] = sku_name
        __props__.__dict__["sku_tier"] = sku_tier
        __props__.__dict__["tags"] = tags
        __props__.__dict__["trace"] = trace
        __props__.__dict__["zone_redundant"] = zone_redundant
        return SpringCloudService(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="buildAgentPoolSize")
    def build_agent_pool_size(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the size for this Spring Cloud Service's default build agent pool. Possible values are `S1`, `S2`, `S3`, `S4` and `S5`. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "build_agent_pool_size")

    @property
    @pulumi.getter(name="configServerGitSetting")
    def config_server_git_setting(self) -> pulumi.Output[Optional['outputs.SpringCloudServiceConfigServerGitSetting']]:
        """
        A `config_server_git_setting` block as defined below. This field is applicable only for Spring Cloud Service with basic and standard tier.
        """
        return pulumi.get(self, "config_server_git_setting")

    @property
    @pulumi.getter(name="containerRegistries")
    def container_registries(self) -> pulumi.Output[Optional[Sequence['outputs.SpringCloudServiceContainerRegistry']]]:
        """
        One or more `container_registry` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "container_registries")

    @property
    @pulumi.getter(name="defaultBuildService")
    def default_build_service(self) -> pulumi.Output[Optional['outputs.SpringCloudServiceDefaultBuildService']]:
        """
        A `default_build_service` block as defined below. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "default_build_service")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        Specifies the supported Azure location where the resource exists. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="logStreamPublicEndpointEnabled")
    def log_stream_public_endpoint_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Should the log stream in vnet injection instance could be accessed from Internet?
        """
        return pulumi.get(self, "log_stream_public_endpoint_enabled")

    @property
    @pulumi.getter(name="managedEnvironmentId")
    def managed_environment_id(self) -> pulumi.Output[Optional[str]]:
        """
        The resource Id of the Managed Environment that the Spring Apps instance builds on. Can only be specified when `sku_tier` is set to `StandardGen2`.
        """
        return pulumi.get(self, "managed_environment_id")

    @property
    @pulumi.getter
    def marketplace(self) -> pulumi.Output['outputs.SpringCloudServiceMarketplace']:
        """
        A `marketplace` block as defined below. Can only be specified when `sku` is set to `E0`.
        """
        return pulumi.get(self, "marketplace")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the name of the Spring Cloud Service resource. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def network(self) -> pulumi.Output[Optional['outputs.SpringCloudServiceNetwork']]:
        """
        A `network` block as defined below. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "network")

    @property
    @pulumi.getter(name="outboundPublicIpAddresses")
    def outbound_public_ip_addresses(self) -> pulumi.Output[Sequence[str]]:
        """
        A list of the outbound Public IP Addresses used by this Spring Cloud Service.
        """
        return pulumi.get(self, "outbound_public_ip_addresses")

    @property
    @pulumi.getter(name="requiredNetworkTrafficRules")
    def required_network_traffic_rules(self) -> pulumi.Output[Sequence['outputs.SpringCloudServiceRequiredNetworkTrafficRule']]:
        """
        A list of `required_network_traffic_rules` blocks as defined below.
        """
        return pulumi.get(self, "required_network_traffic_rules")

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Output[str]:
        """
        Specifies The name of the resource group in which to create the Spring Cloud Service. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "resource_group_name")

    @property
    @pulumi.getter(name="serviceRegistryEnabled")
    def service_registry_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether enable the default Service Registry. This field is applicable only for Spring Cloud Service with enterprise tier.
        """
        return pulumi.get(self, "service_registry_enabled")

    @property
    @pulumi.getter(name="serviceRegistryId")
    def service_registry_id(self) -> pulumi.Output[str]:
        """
        The ID of the Spring Cloud Service Registry.
        """
        return pulumi.get(self, "service_registry_id")

    @property
    @pulumi.getter(name="skuName")
    def sku_name(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the SKU Name for this Spring Cloud Service. Possible values are `B0`, `S0` and `E0`. Defaults to `S0`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_name")

    @property
    @pulumi.getter(name="skuTier")
    def sku_tier(self) -> pulumi.Output[str]:
        """
        Specifies the SKU Tier for this Spring Cloud Service. Possible values are `Basic`, `Enterprise`, `Standard` and `StandardGen2`. The attribute is automatically computed from API response except when `managed_environment_id` is defined. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "sku_tier")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A mapping of tags to assign to the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def trace(self) -> pulumi.Output[Optional['outputs.SpringCloudServiceTrace']]:
        """
        A `trace` block as defined below.
        """
        return pulumi.get(self, "trace")

    @property
    @pulumi.getter(name="zoneRedundant")
    def zone_redundant(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether zone redundancy is enabled for this Spring Cloud Service. Defaults to `false`.
        """
        return pulumi.get(self, "zone_redundant")

